#!/usr/bin/python
# -*- coding: utf-8 -*-

import socket, ssl, time

class Check_Sender(object):
	def __init__(self, addr, port, key_file = None, cert_file = None, ca_file = None):
		self._addr = addr
		self._port = port
		self._cert_file = cert_file
		self._key_file = key_file
		self._ca_file = ca_file
	
	def _send_data(self, data):
		try:
			sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
			sock.connect((self._addr, self._port))
			if(self._cert_file != None and self._key_file != None and self._ca_file != None):
				ssl_ctx = ssl.create_default_context(cafile = self._ca_file)
				ssl_ctx.check_hostname = False
				ssl_ctx.load_cert_chain(certfile = self._cert_file, keyfile = self._key_file)
				sock = ssl_ctx.wrap_socket(sock)
			
			data += '\r\n.'
			while data != '':
				sended = sock.send(data)
				data = data[sended:]
				
			sock.close()
			return True
			
		except:
			return False
		
	def send_host(self, host_name, host_status, msg):
		data = '[%s] PROCESS_HOST_CHECK_RESULT;%s;%s;%s' % (int(time.time()), host_name, host_status, msg)
		return self._send_data(data)
		
	def send_service(self, host_name, service_desc, host_status, msg):
		data = '[%s] PROCESS_SERVICE_CHECK_RESULT;%s;%s;%s;%s' % (int(time.time()), host_name, service_desc, host_status, msg)
		return self._send_data(data)

	def send_custom(self, *params):
		try:
			if(len(params) == 0):
				return False
		
			params = map(lambda x: str(x), params)
			data = '[%s] ' % (int(time.time()),) + ';'.join(params)
			
		except:
			return False
			
		return self._send_data(data)